﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using System.Drawing;
using Infragistics.Win.UltraWinGrid;
using System.Drawing.Imaging;

namespace WinGridChechBoxColor
{
    class MyFilter:IUIElementDrawFilter
    {
        Image img = Image.FromFile("..\\..\\TickMark1.jpg");

        #region IUIElementDrawFilter Members

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            CheckIndicatorUIElement ce = drawParams.Element as CheckIndicatorUIElement;
            if (ce != null && ((Infragistics.Win.CheckEditorCheckBoxUIElement)(ce.Parent)).CheckState == System.Windows.Forms.CheckState.Checked )
            {
                Rectangle rect = ce.Rect;
                rect.Offset(2, 0);
                Color c = (Color)GetRow(ce).Cells["Color"].Value;

                drawParams.DrawImage(img, rect, false, Filter(c,img));
               
            }
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is CheckIndicatorUIElement)
                return DrawPhase.AfterDrawElement;
            return DrawPhase.None;
        }

        private UltraGridRow GetRow(UIElement el)
        {
            if (el == null)
                return null;
            if (el is RowUIElement)
                return ((RowUIElement)el).Row;
            else
                return GetRow(el.Parent);
        }

        public static ImageAttributes Filter(Color color, Image image)

    {
        float r = -1 + ((float)color.R) / 255;
        float g =-1 +((float)color.G) / 255;
        float b = -1 + ((float)color.B) / 255;
        
        ColorMatrix TempMatrix = new ColorMatrix(new float[][]{
                       new float[] {r, 1, 1, 0, 0},
                       new float[] {1, g, 1, 0, 0},
                       new float[] {1, 1, b, 0, 0},
                       new float[] {0, 0, 0, 1, 0},
                       new float[] {0, 0, 0, 0, 1}
                  });

        ImageAttributes atr = new ImageAttributes();  
        atr.SetColorMatrix(TempMatrix);
        return atr;

   }

        #endregion
    }
}
